"""
    DotKnot-PW: software for pairwise RNA pseudoknot prediction
    Copyright (C) 2011-2012 Jana Sperschneider	

    This program is free software; you can redistribute it and/or modify  
    it under the terms of the GNU General Public License as published by  
    the Free Software Foundation; either version 2 of the License, or     
    (at your option) any later version.    
"""
import os
import sys


def is_it_a_sequence(seq):
    seq = seq.upper()
    seq = seq.strip()
    seq = seq.replace('T','U')
    seq = seq.replace(' ','')
    
    for base in seq:
        if base in 'ACGUWSMKRYBDHVNO':
            pass
        else:
            print
            print "Sequence", identifier, "contains invalid characters (other than ACGUWSMKRYBDHVNO)"
            sys.exit(0)

    return seq    
    
                                                                    
def read_input():
    """ Function: read_input()

        Purpose: Given a file with sequences in FASTA format,
                 scan them for correct format. Store sequences
                 in a list.
        Input:   Command line which specifies name of FASTA file.        
        Return:  List which contains sequences from FASTA file.
                 List which contains identifiers from FASTA file.
    """     
    # Read fasta file with multiple sequences from user input in command line

    try:
        fasta_file = sys.argv[-1]
        f = open(fasta_file,'U')
        
        # Store ids and sequences in list
        file_content = []
        for line in f:
            line = line.strip()
            if line:
                file_content.append(line)
                
    except IOError:
        print "Specify input file!"
        sys.exit(0)
        
    list_of_ids, list_of_dictionaries = [], []

    if file_content:   
    
        for i in xrange(0,len(file_content),2):
            identifier = file_content[i]
            list_of_ids.append(identifier.strip())
                
            try:
                seq = file_content[i + 1]                        
                seq = is_it_a_sequence(seq)
                
                # Each sequence has a number count
                list_of_dictionaries.append(seq)        # Append sequence
            except:
                print "ID ", identifier, "has no sequence following in the FASTA file!"
                print
                sys.exit(0)
                        
    return list_of_ids, list_of_dictionaries
